#!/usr/bin/perl
use Math::Trig;
$datadir="$ARGV[1]";
$librarydir="$ARGV[0]";
$M=5; #### in an order of confidence

%NAME=(
       1=>"MUSTER",
       2=>"dPPA",
       3=>"wdPPA",
       4=>"wMUSTER",
       5=>"wPPA",
       6=>"dPPA2",
       7=>"PPA",
       8=>"sPPA",
       );
%INIT=(
       'MUSTER'=>"init.MUSTER",
       'dPPA'=>"init.dPPA",
       'wdPPA'=>"init.wdPPA",
       'wPPA'=>"init.wPPA",
       'wMUSTER'=>"init.wMUSTER",
       'dPPA2'=>"init.dPPA2",
       'PPA'=>"init.PPA",
       'sPPA'=>"init.sPPA",
       );
@stands=qw(
           dPPA
           MUSTER
           wdPPA
           wPPA
           wMUSTER
           dPPA2
           PPA
           sPPA
           );
%zscore0=(
          'MUSTER'=>5.8,
          'dPPA'=>9.3,
          'wdPPA'=>9.3,
          'wPPA'=>7.0,
          'wMUSTER'=>5.8,
          'dPPA2'=>10.5,
          'PPA'=>7.0,
          'sPPA'=>8.0,
          );


$n_top=15;
####### get average n_good -------->
    $n=0;
    $n_good0=0;
    undef %i_good0;
    foreach $stand(@stands)
    {
	if(-s "$datadir/$INIT{$stand}")
	{
	    $n++;
	    open(init,"$datadir/$INIT{$stand}");
	    <init>=~/(\S+)/;
	    $Nt=$1;
	    for($i=1;$i<=$Nt;$i++)
	    {
		$line=<init>;
		if($line=~/(\S+)\s+(\S+)/)
		{
		    $La=$1;
		    $z=$2;
		    if($z>=$zscore0{$stand})
		    {
			$n_good0++;
			$i_good0{$stand}++;
		    }
		    for($j=1;$j<=$La+1;$j++)
		    {
			<init>;
		    }
		}
	    }
	}
    }
### if multiple hits by one algorithm ---->
    $max_allow_for1=2;
    foreach $stand(@stands)
    {
	if($i_good0{$stand} == $n_good0 && $n_good0 >$max_allow_for1)
	{
	    $i_good0{$stand}=$max_allow_for1;
	}
    }
    $n_good0=0;
    foreach $stand(@stands)
    {
	if($i_good0{$stand} >5)
	{
	    $i_good0{$stand}=5;
	}
	$n_good0+=$i_good0{$stand};
    }
    $n_good0=($n_good0+0.11)/($n+0.1);
    $n_gooda=int($n_good0);
    #printf "n_gooda=$n_gooda n=$n\n";
    
    ###### initialization ################
    $num_temp=0;  #number of templates
    $n_good=0;  #total number of good templates
    undef %nscore;
    undef %i_good; #number of good templates (zscore>zscore0 && L_ali>Lch/2)
    undef %N_temp;
    
    ########### get Lch ########
    open(rmsinp,"$datadir/rmsinp");
    <rmsinp>=~/\S+\s+(\S+)/;
    $Lch=$1;
    close(rmsinp);
    open(seqdat,"$datadir/seq.dat");
    for($i=1;$i<=$Lch;$i++)
    {
	<seqdat>=~/\S+\s+(\S+)/;
	$seqQ{$i}=$1;
    }
    close(seqdat);
    
    ########## read templates #############
    $M0=0;
    for($m=1;$m<=$M;$m++)
    {
	$initdat="$datadir/$INIT{$NAME{$m}}";
	if(!-s "$initdat")
	{
	    printf "without init: $initdat\n";
	    goto pos3_1b;
	}
	
	######## read template ---------->
	open(initdat,"$initdat");
	if(<initdat>=~/(\S+)/)
	{
	    $N_tmp=$1;
	}
	$k=0;
	$N_tmp=$n_top if($N_tmp>$n_top);
	for($i=1;$i<=$N_tmp;$i++)
	{
	    $line=<initdat>;
	    if($line=~/(\S+)\s+(\S+)\s+\d+\s+(\S+)/)
	    {
		$L_ali_tmp=$1;
		if($L_ali_tmp>0)
		{
		    $k++;
		    $num_temp++;
		    $sign{$k}="bad";
		    $L_aliT{$m,$k}=$1;
		    $zscoreT{$m,$k}=$2;
		    $template_nameT{$m,$k}=$3;
		    if($zscore0{$NAME{$m}}>0)
		    {
			if($zscoreT{$m,$k}>$zscore0{$NAME{$m}})
			{
			    $sign{$k}="good";
			    $i_good{$m}++;
			    $n_good++;
			}
		    }
		    else
		    {
			if($i<=$n_gooda)
			{
			    $sign{$k}="good";
			    $i_good{$m}++;
			    $n_good++;
			}
		    }
		    if($NAME{$m} eq "ROS" && $i==1 && $sign{$k} ne "good")
		    {
			$sign{$k}="good";
			$i_good{$m}++;
			$n_good++;
		    }
		    $mar="new";
		    for($j=1;$j<=$L_aliT{$m,$k};$j++)
		    {
			$line=<initdat>;
			$res=substr($line,22,4);
			$res=~s/\s//mg;
			$a=substr($line,17,3);
			if($a ne $seqQ{$res})
			{
			    printf "$NAME{$m} warning: $a ne $seqQ{$res} for res=$res, convert $a to $seqQ{$res}\n";
			    if($mar eq "new")
			    {
				$mar="old";
			    }
			    $a=$seqQ{$res};
			}
			$LINET{$m,$k,$j}=substr($line,0,17).$a.substr($line,20);
		    }
		}
	    }
	    <initdat>;
	}
	close(initdat);
	$N_temp{$m}=$k;
	$M0++ if($N_temp{$m}>0);
	
	######## upgrade good templates ------------->
	$j=0;
	for($i=1;$i<=$N_temp{$m};$i++)
	{
	    if($sign{$i} eq "good")
	    {
		$j++;
		$L_ali{$m,$j}=$L_aliT{$m,$i};
		$zscore{$m,$j}=$zscoreT{$m,$i};
		$template_name{$m,$j}=$template_nameT{$m,$i};
		for($k=1;$k<=$L_aliT{$m,$i};$k++)
		{
		    $LINE{$m,$j,$k}=$LINET{$m,$i,$k};
		}
	    }
	}
	for($i=1;$i<=$N_temp{$m};$i++)
	{
	    if($sign{$i} eq "bad")
	    {
		$j++;
		$L_ali{$m,$j}=$L_aliT{$m,$i};
		$zscore{$m,$j}=$zscoreT{$m,$i};
		$template_name{$m,$j}=$template_nameT{$m,$i};
		for($k=1;$k<=$L_aliT{$m,$i};$k++)
		{
		    $LINE{$m,$j,$k}=$LINET{$m,$i,$k};
		}
	    }
	}
      pos3_1b:;
    }
    
#	printf "ori: ";
#	for($i=1;$i<=$M;$i++)
#	{
#	printf " %4s",$NAME{$i};
#	}
#	printf "\n";
#	printf "     ";
#	for($i=1;$i<=$M;$i++)
#	{
#	printf "   %2d",$N_temp{$i};
#	}
#	printf "\n";
#	printf "     ";
#	for($i=1;$i<=$M;$i++)
#	{
#	printf "   %2d",$i_good{$i};
#	}
#	printf "\n";
    ### if multiple hits by one algorithm ---->
    $max_allow_for1=2;
    for($m=1;$m<=$M;$m++)
    {
	if($i_good{$m} == $n_good && $n_good >$max_allow_for1)
	{
	    $i_good{$m}=$max_allow_for1;
	    $n_good=$max_allow_for1;
	}
    }
    ### maximum 5 for each server ----------->
    $n_good=0;
    $n_max=5;
    for($m=1;$m<=$M;$m++)
    {
	if($i_good{$m}>$n_max)
	{
	    $i_good{$m}=$n_max;
	}
	$n_good+=$i_good{$m};
    }
    
    ######## decide type of targets ##########
    $M1=$M0/4.9;
    if($n_good>=$M0)
    {
	$type="easy";
    }
    elsif($n_good >=$M1)
    {
	$type="medm";
    }
    else
    {
	$type="hard";
    }
    #printf "$type:";
    for($i=1;$i<=$M;$i++)
    {
	#printf " %4s",$NAME{$i};
    }
    #printf "\n";
    #printf "     ";
    for($i=1;$i<=$M;$i++)
    {
	#printf "   %2d",$i_good{$i};
    }
    #printf "\n";
    
    ###### decide rule of collecting template ------->
    $n_sg=0;  #number of servers with good templates
    for($m=1;$m<=$M;$m++)
    {
	$n_sg++ if($i_good{$m}>0);
    }
    $role="SEQ"; #templates taken sequentially
    if($type eq "easy")
    {
	if($n_sg <= $M0/2)
	{
	    $role="SEL"; # templates taken selectively
	}
    }
    if($type eq "medm")
    {
	$role="SEL";
    }
    if($type eq "hard")
    {
	if($n_sg >=2)
	{
	    $role="SEL"; # templates taken selectively
	}
    }
    
    ############## rule out FFF only medium ##########
    printf "type=%5s, n_good=%2d, M0=%2d, M1_for_medm=%3.1f, n_sg=%2d role=%3s\n",
    $type,$n_good,$M0,$M1,$n_sg,$role;
    
    ##################################################
    ##### output "init_all.dat"------->
    ##################################################
    open(initall,">$datadir/init.dat");
    printf initall "%3d %4s %3d %3d\n",
    $num_temp,$type,$n_good,$M0;
    if($role eq "SEQ")
    { # template sequentially
	$i_temp=0;
	for($i=1;$i<=$n_top;$i++)
	{
	    for($m=1;$m<=$M;$m++)
	    {
		if($i<=$N_temp{$m})
		{
		    $i_temp++;
		    printf initall "%8d %8.3f %3d %6s %5s\n",
		    $L_ali{$m,$i},$zscore{$m,$i},$i_temp,
		    $template_name{$m,$i},$NAME{$m};
		    for($j=1;$j<=$L_ali{$m,$i};$j++)
		    {
			printf initall "$LINE{$m,$i,$j}";
		    }
		    printf initall "TER\n";
		}
	    }
	}
    }
    else
    { #templates taken selectively
	####### output good templates:
	$i_temp=0;
	for($i=1;$i<=$n_top;$i++)
	{
	    for($m=1;$m<=$M;$m++)
	    {
		if($i<=$N_temp{$m})
		{
		    if($i<=$i_good{$m})
		    {
			$i_temp++;
			printf initall "%8d %8.3f %3d %6s %5s\n",
			$L_ali{$m,$i},$zscore{$m,$i},$i_temp,
			$template_name{$m,$i},$NAME{$m};
			for($j=1;$j<=$L_ali{$m,$i};$j++)
			{
			    printf initall "$LINE{$m,$i,$j}";
			}
			printf initall "TER\n";
		    }
		}
	    }
	}
	####### bad templates:
	# re-order the bad templates:
	undef %kM;
	for($m=1;$m<=$M;$m++)
	{
	    $k=0;
	    for($i=1;$i<=$N_temp{$m};$i++)
	    {
		if($i>$i_good{$m})
		{
		    $k++;
		    $kk{$m,$k}=$i;
		}
	    }
	    $kM{$m}=$k;
	}
	# output bad template in the order of m=1,M
	for($k=1;$k<=$n_top;$k++)
	{
	    for($m=1;$m<=$M;$m++)
	    {
		if($k<=$kM{$m})
		{
		    $i=$kk{$m,$k};
		    $i_temp++;
		    printf initall "%8d %8.3f %3d %6s %5s\n",
		    $L_ali{$m,$i},$zscore{$m,$i},$i_temp,
		    $template_name{$m,$i},$NAME{$m};
		    for($j=1;$j<=$L_ali{$m,$i};$j++){
			printf initall "$LINE{$m,$i,$j}";
		    }
		    printf initall "TER\n";
		}
	    }
	}
    }
    close(initall);
  exit(); 
